Index: trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F	(revision 787)
@@ -72,4 +72,7 @@
 #include "comgeom2.h"
 #include "control.h"
+
+#include "advtrac.h"
+!! this is to get tnom (tracers name)
 
 c    Arguments :
@@ -422,4 +425,5 @@
 
       CALL physiq (ngridmx,llm,nq,
+     .     tnom,
      ,     debut,lafin,
      ,     rday_ecri,heure,dtphys,
Index: trunk/LMDZ.GENERIC/libf/dyn3d/ini_archive.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/dyn3d/ini_archive.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/dyn3d/ini_archive.F	(revision 787)
@@ -34,4 +34,6 @@
 
 c=======================================================================
+
+      USE comsoil_h
  
       implicit none
@@ -49,5 +51,4 @@
 #include "serre.h"
 #include "control.h"
-#include"comsoil.h"
 
 #include "netcdf.inc"
Index: trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/dyn3d/lect_start_archive.F	(revision 787)
@@ -3,4 +3,8 @@
      &     q,qsurf,surfith,nid)
 
+      USE surfdat_h
+      USE comsoil_h
+      USE tracer_h
+
 c=======================================================================
 c
@@ -22,6 +26,4 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "surfdat.h"
-#include "comsoil.h"
 #include "planete.h"
 #include "paramet.h"
@@ -36,5 +38,4 @@
 #include "lmdstd.h"
 #include "netcdf.inc"
-#include "tracer.h"
 #include"advtrac.h"
 c=======================================================================
Index: trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/dyn3d/newstart.F	(revision 787)
@@ -15,10 +15,13 @@
 c=======================================================================
 
+      USE tracer_h
+      USE comsoil_h
+      USE surfdat_h
+      USE comgeomfi_h
+
       implicit none
 
 #include "dimensions.h"
 #include "dimphys.h"
-#include "surfdat.h"
-#include "comsoil.h"
 #include "planete.h"
 #include "paramet.h"
@@ -37,5 +40,4 @@
 #include "netcdf.inc"
 #include "advtrac.h"
-#include "tracer.h"
 c=======================================================================
 c   Declarations
@@ -243,4 +245,9 @@
       ! tnom(:) now contains tracer names
 ! JL12 we will need the tracer names to read start in dyneta0
+
+! Initialize global tracer indexes (stored in tracer.h)
+! ... this has to be done before phyetat0
+      call initracer(ngridmx,nqmx,tnom)
+
 
 c-----------------------------------------------------------------------
@@ -293,7 +300,14 @@
      .       ps,phis,time)
 
+
+        ! ALLOCATE ARRAYS IN comgeomfi_h (done in inifis usually)
+        IF (.not. ALLOCATED(lati)) ALLOCATE(lati(ngridmx))
+        IF (.not. ALLOCATED(long)) ALLOCATE(long(ngridmx))
+        IF (.not. ALLOCATED(area)) ALLOCATE(area(ngridmx))
+        cursor = 1 ! added by AS in dimphys. 1 for sequential runs.
+
         write(*,*) 'Reading file STARTFI'
         fichnom = 'startfi.nc'
-        CALL phyetat0 (fichnom,tab0,Lmodif,nsoilmx,nqmx,
+        CALL phyetat0 (ngridmx,fichnom,tab0,Lmodif,nsoilmx,nqmx,
      .        day_ini,time,
      .        tsurf,tsoil,emis,q2,qsurf,   !) ! temporary modif by RDW
@@ -352,9 +366,9 @@
 c-----------------------------------------------------------------------
       if (choix_1.eq.0) then
-         call tabfi (nid,Lmodif,tab0,day_ini,lllm,p_rad,
+         call tabfi (ngridmx,nid,Lmodif,tab0,day_ini,lllm,p_rad,
      .            p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time)
       else if (choix_1.eq.1) then
          Lmodif=1 ! Lmodif set to 1 to allow modifications in phyeta0                           
-         call tabfi (nid_fi,Lmodif,tab0,day_ini,lllm,p_rad,
+         call tabfi (ngridmx,nid_fi,Lmodif,tab0,day_ini,lllm,p_rad,
      .            p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time)
       endif
@@ -369,10 +383,7 @@
       kappa = 8.314*1000./(p_mugaz*p_cpp) ! added by RDW
 
-
 c=======================================================================
 c  INITIALISATIONS DIVERSES
 c=======================================================================
-! Initialize global tracer indexes (stored in tracer.h)
-      call initracer()
 ! Load parameters from run.def file
       CALL defrun_new( 99, .TRUE. )
@@ -1413,9 +1424,9 @@
 
 
-      call physdem1("restartfi.nc",lonfi,latfi,nsoilmx,nqmx,
+      call physdem1(ngridmx,"restartfi.nc",lonfi,latfi,nsoilmx,nqmx,
      .              dtphys,float(day_ini),
      .              time,tsurf,tsoil,emis,q2,qsurf,
      .              airefi,albfi,ithfi,zmea,zstd,zsig,zgam,zthe,
-     .              cloudfrac,totalfrac,hice)
+     .              cloudfrac,totalfrac,hice,tnom)
 
 c=======================================================================
Index: trunk/LMDZ.GENERIC/libf/dyn3d/start2archive.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/dyn3d/start2archive.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/dyn3d/start2archive.F	(revision 787)
@@ -18,4 +18,6 @@
 c
 c=======================================================================
+
+      USE comsoil_h
 
       implicit none
@@ -34,5 +36,4 @@
 
 #include "dimphys.h"
-#include "comsoil.h"
 #include "planete.h"
 #include"advtrac.h"
@@ -162,5 +163,6 @@
       Lmodif=0
 
-      CALL phyetat0 (fichnom,0,Lmodif,nsoilmx,nqmx,day_ini_fi,timefi,
+      CALL phyetat0 (ngridmx,fichnom,0,Lmodif,nsoilmx,nqmx,day_ini_fi,
+     .      timefi,
      .      tsurf,tsoil,emis,q2,qsurf,
 !       change FF 05/2011
Index: trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 787)
@@ -4,4 +4,6 @@
        use radinc_h, only : L_TAUMAX,naerkind
        use aerosol_mod
+       USE comgeomfi_h
+       USE tracer_h
                   
        implicit none
@@ -28,6 +30,6 @@
 !     pq                Aerosol mixing ratio
 !     reffrad(ngrid,nlayer,naerkind)         Aerosol effective radius
-!     QREFvis3d(ngridmx,nlayermx,naerkind) \ 3d extinction coefficients
-!     QREFir3d(ngridmx,nlayermx,naerkind)  / at reference wavelengths
+!     QREFvis3d(ngrid,nlayermx,naerkind) \ 3d extinction coefficients
+!     QREFir3d(ngrid,nlayermx,naerkind)  / at reference wavelengths
 !
 !     Output
@@ -42,6 +44,4 @@
 #include "callkeys.h"
 #include "comcstfi.h"
-#include "comgeomfi.h"
-#include "tracer.h"
 #include "comvert.h"
 
@@ -53,11 +53,11 @@
       REAL aerosol(ngrid,nlayer,naerkind)
       REAL reffrad(ngrid,nlayer,naerkind)
-      REAL QREFvis3d(ngridmx,nlayermx,naerkind)
-      REAL QREFir3d(ngridmx,nlayermx,naerkind)
+      REAL QREFvis3d(ngrid,nlayermx,naerkind)
+      REAL QREFir3d(ngrid,nlayermx,naerkind)
 
       REAL tau_col(ngrid)
 !      REAL tauref(ngrid), tau_col(ngrid)
 
-      real cloudfrac(ngridmx,nlayermx)
+      real cloudfrac(ngrid,nlayermx)
       real aerosol0
 
@@ -77,9 +77,9 @@
       ! for fixed dust profiles
       real topdust, expfactor, zp
-      REAL taudusttmp(ngridmx) ! Temporary dust opacity used before scaling
-      REAL tauh2so4tmp(ngridmx) ! Temporary h2so4 opacity used before scaling
+      REAL taudusttmp(ngrid) ! Temporary dust opacity used before scaling
+      REAL tauh2so4tmp(ngrid) ! Temporary h2so4 opacity used before scaling
       ! BENJAMIN MODIFS
       real CLFtot
-      real totcloudfrac(ngridmx)
+      real totcloudfrac(ngrid)
       logical clearsky
 
@@ -87,21 +87,6 @@
       IF (firstcall) THEN
 
-         ! are these tests of any real use ?
-        IF(ngrid.NE.ngridmx) THEN
-            PRINT*,'STOP in aeropacity!'
-            PRINT*,'problem of dimensions:'
-            PRINT*,'ngrid  =',ngrid
-            PRINT*,'ngridmx  =',ngridmx
-            STOP
-        ENDIF
-
-        if (nq.gt.nqmx) then
-           write(*,*) 'STOP in aeropacity: (nq .gt. nqmx)!'
-           write(*,*) 'nq=',nq,' nqmx=',nqmx
-           stop
-        endif
-
         write(*,*) "Tracers found in aeropacity:"
-        do iq=1,nqmx
+        do iq=1,nq
           tracername=noms(iq)
           if (tracername.eq."co2_ice") then
@@ -150,11 +135,11 @@
            iaer=iaero_co2
 !       1. Initialization
-            aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
 !       2. Opacity calculation
             if (noaero) then ! aerosol set to a very low value
-             aerosol(1:ngridmx,1:nlayermx,iaer)=1.e-9
+             aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
             elseif (aerofixco2.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
-               aerosol(1:ngridmx,1:nlayermx,iaer)=1.e-9
-               !aerosol(1:ngridmx,12,iaer)=4.0 ! single cloud layer option
+               aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
+               !aerosol(1:ngrid,12,iaer)=4.0 ! single cloud layer option
             else
                DO ig=1, ngrid
@@ -187,8 +172,8 @@
            iaer=iaero_h2o
 !       1. Initialization
-            aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
 !       2. Opacity calculation
             if (aerofixh2o.or.(i_h2oice.eq.0).or.clearsky) then
-               aerosol(1:ngridmx,1:nlayermx,iaer) =1.e-9
+               aerosol(1:ngrid,1:nlayermx,iaer) =1.e-9
 
                ! put cloud at cloudlvl
@@ -241,5 +226,5 @@
 
                if(CLFvarying)then
-                  call totalcloudfrac(cloudfrac,totcloudfrac,pplev,pq,aerosol(1:ngridmx,1:nlayermx,iaer))
+                  call totalcloudfrac(ngrid,nq,cloudfrac,totcloudfrac,pplev,pq,aerosol(1:ngrid,1:nlayermx,iaer))
                   do ig=1, ngrid
                      do l=1,nlayer-1 ! to stop the rad tran bug
@@ -268,5 +253,5 @@
           iaer=iaero_dust
 !         1. Initialization 
-          aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
+          aerosol(1:ngrid,1:nlayermx,iaer)=0.0
           
           topdust=30.0 ! km  (used to be 10.0 km) LK
@@ -322,5 +307,5 @@
 
 !       1. Initialization
-         aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
+         aerosol(1:ngrid,1:nlayermx,iaer)=0.0
 
 
@@ -386,5 +371,5 @@
       end do
 
-      do ig=1, ngrid
+      do ig=1,ngrid
          do l=1,nlayer
             do iaer = 1, naerkind
@@ -399,5 +384,5 @@
       end do
 
-      do ig=1, ngrid
+      do ig=1,ngrid
          if(tau_col(ig).gt.1.e3)then
             print*,'WARNING: tau_col=',tau_col(ig)
Index: trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 787)
@@ -60,5 +60,5 @@
       INTEGER :: grid_i,grid_j
 !     Intermediate variable
-      REAL :: var_tmp,var3d_tmp(ngridmx,nlayermx)
+      REAL :: var_tmp,var3d_tmp(ngrid,nlayermx)
 !     Bilinear interpolation factors
       REAL :: kx,ky,k1,k2,k3,k4
@@ -161,24 +161,24 @@
       INTEGER :: ngrid,nlayer
 !     Aerosol effective radius used for radiative transfer (meter)
-      REAL :: reffrad(ngridmx,nlayermx,naerkind)
+      REAL :: reffrad(ngrid,nlayermx,naerkind)
 !     Aerosol effective variance used for radiative transfer (n.u.)
-      REAL :: nueffrad(ngridmx,nlayermx,naerkind)
+      REAL :: nueffrad(ngrid,nlayermx,naerkind)
 
 !     Outputs
 !     -------
 
-      REAL :: QVISsQREF3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-
-      REAL :: QREFvis3d(ngridmx,nlayermx,naerkind)
-      REAL :: QREFir3d(ngridmx,nlayermx,naerkind)
-
-      REAL :: omegaREFvis3d(ngridmx,nlayermx,naerkind)
-      REAL :: omegaREFir3d(ngridmx,nlayermx,naerkind)
+      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+
+      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+
+      REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
+      REAL :: QREFir3d(ngrid,nlayermx,naerkind)
+
+      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
+      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind)
 
       DO iaer = 1, naerkind ! Loop on aerosol kind
@@ -380,5 +380,5 @@
 
       DO lg = 1,nlayer
-        DO ig = 1,ngrid
+        DO ig = 1, ngrid
 !         2.1 Effective radius index and kx calculation
           var_tmp=reffrad(ig,lg,iaer)/refftabmin
@@ -725,5 +725,5 @@
           ENDIF                  ! --------------------------------
         ENDDO !nlayermx
-      ENDDO !ngridmx
+      ENDDO !ngrid
 
 !==================================================================
Index: trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 787)
@@ -22,5 +22,5 @@
   real Play(1:nlayermx),Plev(1:nlayermx+1)
   real Qsurf,Q(1:nlayermx)
-  real muvar(ngridmx,nlayermx+1)
+  real muvar(1,nlayermx+1)
 
   ! internal
Index: trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 787)
@@ -5,5 +5,5 @@
           fluxsurf_sw,fluxtop_lw,fluxabs_sw,fluxtop_dn,        &
           OLR_nu,OSR_nu,                                       &
-          reffrad,tau_col,cloudfrac,totcloudfrac,              &
+          reffrad,nueffrad,tau_col,cloudfrac,totcloudfrac,     &
           clearsky,firstcall,lastcall)
 
@@ -16,4 +16,6 @@
       use radii_mod, only : su_aer_radii,co2_reffrad,h2o_reffrad,dust_reffrad,h2so4_reffrad
       use aerosol_mod
+
+      USE tracer_h
 
       implicit none
@@ -37,5 +39,4 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
 
 !-----------------------------------------------------------------------
@@ -60,31 +61,30 @@
 !     Globally varying aerosol optical properties on GCM grid
 !     Not needed everywhere so not in radcommon_h
-      REAL :: QVISsQREF3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngridmx,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngridmx,nlayermx,L_NSPECTI,naerkind)
-
-      REAL :: QREFvis3d(ngridmx,nlayermx,naerkind)
-      REAL :: QREFir3d(ngridmx,nlayermx,naerkind)
-
-!      REAL :: omegaREFvis3d(ngridmx,nlayermx,naerkind)
-!      REAL :: omegaREFir3d(ngridmx,nlayermx,naerkind) ! not sure of the point of these...
-
-      REAL reffrad(ngrid,nlayer,naerkind)
-      REAL, SAVE :: nueffrad(ngridmx,nlayermx,naerkind)
-
-!     OUTPUT
-      REAL dtsw(ngridmx,nlayermx) ! heating rate (K/s) due to SW
-      REAL dtlw(ngridmx,nlayermx) ! heating rate (K/s) due to LW
-      REAL fluxsurf_lw(ngridmx)   ! incident LW flux to surf (W/m2)
-      REAL fluxtop_lw(ngridmx)    ! outgoing LW flux to space (W/m2)
-      REAL fluxsurf_sw(ngridmx)   ! incident SW flux to surf (W/m2)
-      REAL fluxabs_sw(ngridmx)    ! SW flux absorbed by planet (W/m2)
-      REAL fluxtop_dn(ngridmx)    ! incident top of atmosphere SW flux (W/m2)
+      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
+
+      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
+
+!      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
+!      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind) ! not sure of the point of these...
+
+      !!! this is a local instance of a variable saved in physiq.F and being an argument
+      REAL, INTENT(INOUT) :: reffrad(ngrid,nlayer,naerkind)
+      REAL, INTENT(INOUT) :: nueffrad(ngrid,nlayermx,naerkind)
+
+!!     OUTPUT
+      REAL dtsw(ngrid,nlayermx) ! heating rate (K/s) due to SW
+      REAL dtlw(ngrid,nlayermx) ! heating rate (K/s) due to LW
+      REAL fluxsurf_lw(ngrid)   ! incident LW flux to surf (W/m2)
+      REAL fluxtop_lw(ngrid)    ! outgoing LW flux to space (W/m2)
+      REAL fluxsurf_sw(ngrid)   ! incident SW flux to surf (W/m2)
+      REAL fluxabs_sw(ngrid)    ! SW flux absorbed by planet (W/m2)
+      REAL fluxtop_dn(ngrid)    ! incident top of atmosphere SW flux (W/m2)
       REAL OLR_nu(ngrid,L_NSPECTI)! Outgoing LW radition in each band (Normalized to the band width (W/m2/cm-1)
       REAL OSR_nu(ngrid,L_NSPECTV)! Outgoing SW radition in each band (Normalized to the band width (W/m2/cm-1)
+
 !-----------------------------------------------------------------------
 !     Declaration of the variables required by correlated-k subroutines
@@ -126,6 +126,6 @@
 
       real*8 qvar(L_LEVELS)          ! mixing ratio of variable component (mol/mol)
-      REAL pq(ngridmx,nlayer,nq)
-      REAL qsurf(ngridmx,nqmx)       ! tracer on surface (e.g. kg.m-2)
+      REAL pq(ngrid,nlayer,nq)
+      REAL qsurf(ngrid,nq)       ! tracer on surface (e.g. kg.m-2)
       integer nq
 
@@ -140,5 +140,10 @@
       save qxvaer, qsvaer, gvaer
       save qxiaer, qsiaer, giaer
-      save QREFvis3d, QREFir3d 
+
+      !REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
+      !REAL :: QREFir3d(ngrid,nlayermx,naerkind)
+      !save QREFvis3d, QREFir3d 
+      real, dimension(:,:,:), save, allocatable :: QREFvis3d
+      real, dimension(:,:,:), save, allocatable :: QREFir3d
 
       REAL tau_col(ngrid) ! diagnostic from aeropacity
@@ -165,10 +170,10 @@
 
 !     for H2O cloud fraction in aeropacity
-      real cloudfrac(ngridmx,nlayermx)
-      real totcloudfrac(ngridmx)
+      real cloudfrac(ngrid,nlayermx)
+      real totcloudfrac(ngrid)
       logical clearsky
 
       ! for weird cloud test
-      real pqtest(ngridmx,nlayer,nq)
+      real pqtest(ngrid,nlayer,nq)
 
       real maxrad, minrad
@@ -178,5 +183,5 @@
 
 !     included by RW for runaway greenhouse 1D study
-      real muvar(ngridmx,nlayermx+1)
+      real muvar(ngrid,nlayermx+1)
       real vtmp(nlayermx)
       REAL*8 muvarrad(L_LEVELS)
@@ -195,4 +200,7 @@
 
       if(firstcall) then
+
+         ALLOCATE(QREFvis3d(ngrid,nlayermx,naerkind))
+         ALLOCATE(QREFir3d(ngrid,nlayermx,naerkind))
 
          call system('rm -f surf_vals_long.out')
@@ -204,5 +212,5 @@
             call abort
          endif
-         call su_aer_radii(reffrad,nueffrad)
+         call su_aer_radii(ngrid,reffrad,nueffrad)
 	 
 	 
@@ -233,5 +241,5 @@
          OSR_nu(:,:) = 0.
 
-         if (ngridmx.eq.1) then
+         if (ngrid.eq.1) then
            PRINT*, 'Simulate global averaged conditions ?'
            global1d = .false. ! default value
@@ -266,19 +274,19 @@
 
          if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! treat condensed co2 particles.
-	    call co2_reffrad(pq,reffrad)
-            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+	    call co2_reffrad(ngrid,nq,pq,reffrad)
+            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
 	 end if
          if ((iaer.eq.iaero_h2o).and.water) then ! treat condensed water particles. to be generalized for other aerosols
-	    call h2o_reffrad(pq,pt,reffrad,nueffrad)
-            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+	    call h2o_reffrad(ngrid,nq,pq,pt,reffrad,nueffrad)
+            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
          endif
          if(iaer.eq.iaero_dust)then
-	    call dust_reffrad(reffrad)
+	    call dust_reffrad(ngrid,reffrad)
             print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          if(iaer.eq.iaero_h2so4)then
-	    call h2so4_reffrad(reffrad)
+	    call h2so4_reffrad(ngrid,reffrad)
             print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
@@ -304,5 +312,5 @@
 !-----------------------------------------------------------------------
 !     Starting Big Loop over every GCM column
-      do ig=1,ngridmx
+      do ig=1,ngrid
 
 !=======================================================================
@@ -452,5 +460,5 @@
       endif
 
-      if ((ngridmx.eq.1).and.(global1d)) then       ! fixed zenith angle 'szangle' in 1D simulations w/ globally-averaged sunlight
+      if ((ngrid.eq.1).and.(global1d)) then       ! fixed zenith angle 'szangle' in 1D simulations w/ globally-averaged sunlight
          acosz = cos(pi*szangle/180.0)
          print*,'acosz=',acosz,', szangle=',szangle
@@ -550,5 +558,5 @@
          !i_var=igcm_h2o_vap
          i_var=1
-         if(nqmx.gt.1)then
+         if(nq.gt.1)then
             print*,'Need 1 tracer only to run kcm1d.e' 
             stop
@@ -653,5 +661,5 @@
             fluxtoplanet=0.
 
-            if((ngridmx.eq.1).and.(global1d))then
+            if((ngrid.eq.1).and.(global1d))then
                do nw=1,L_NSPECTV
                   stel_fract(nw)= stel(nw) * 0.25 / acosz
Index: trunk/LMDZ.GENERIC/libf/phystd/callsedim.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 787)
@@ -2,4 +2,7 @@
      $                pplev,zlev, pt,
      &                pq, pdqfi, pdqsed,pdqs_sed,nq,rfall)
+
+      USE tracer_h
+
       IMPLICIT NONE
 
@@ -25,8 +28,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
 #include "callkeys.h"
-
-#include "fisice.h"
 
 c   arguments:
@@ -53,10 +53,10 @@
       INTEGER l,ig, iq
 
-      real zqi(ngridmx,nlayermx,nqmx) ! to locally store tracers
-      real masse (ngridmx,nlayermx) ! Layer mass (kg.m-2)
-      real epaisseur (ngridmx,nlayermx) ! Layer thickness (m)
-      real wq(ngridmx,nlayermx+1) ! displaced tracer mass (kg.m-2)
-c      real dens(ngridmx,nlayermx) ! Mean density of the ice part. accounting for dust core
-      real rfall(ngridmx,nlayermx)
+      real zqi(ngrid,nlayermx,nq) ! to locally store tracers
+      real masse (ngrid,nlayermx) ! Layer mass (kg.m-2)
+      real epaisseur (ngrid,nlayermx) ! Layer thickness (m)
+      real wq(ngrid,nlayermx+1) ! displaced tracer mass (kg.m-2)
+c      real dens(ngrid,nlayermx) ! Mean density of the ice part. accounting for dust core
+      real rfall(ngrid,nlayermx)
 
 
@@ -69,12 +69,4 @@
 
       IF (firstcall) THEN
-         IF(ngrid.NE.ngridmx) THEN
-            PRINT*,'STOP dans callsedim'
-            PRINT*,'probleme de dimensions :'
-            PRINT*,'ngrid  =',ngrid
-            PRINT*,'ngridmx  =',ngridmx
-            STOP
-         ENDIF
-      
         firstcall=.false.
       ENDIF ! of IF (firstcall)
@@ -96,5 +88,5 @@
 !  of general tracers.]
  
-      zqi(1:ngrid,1:nlay,1:nqmx) = 0.
+      zqi(1:ngrid,1:nlay,1:nq) = 0.
       do iq=1,nq
        if((radius(iq).gt.1.e-9).and.(iq.ne.igcm_co2_ice)) then   
@@ -104,5 +96,5 @@
 
           do l=1,nlay 
-            do ig=1,ngrid
+            do ig=1, ngrid
               zqi(ig,l,iq)=pq(ig,l,iq)+pdqfi(ig,l,iq)*ptimestep
             enddo
@@ -128,5 +120,5 @@
 !======================================================================
 
-          do ig=1,ngrid 
+          do ig=1,ngrid
 !     Ehouarn: with new way of tracking tracers by name, this is simply
             pdqs_sed(ig,iq) = wq(ig,1)/ptimestep
Index: trunk/LMDZ.GENERIC/libf/phystd/comdiurn_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/comdiurn_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/comdiurn_h.F90	(revision 787)
@@ -0,0 +1,10 @@
+
+       module comdiurn_h
+
+       implicit none
+
+       real, allocatable, dimension(:) :: sinlon, coslon, sinlat, coslat
+       logical :: ldiurn
+
+       end module comdiurn_h
+
Index: trunk/LMDZ.GENERIC/libf/phystd/comgeomfi_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/comgeomfi_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/comgeomfi_h.F90	(revision 787)
@@ -0,0 +1,10 @@
+
+       module comgeomfi_h
+
+       implicit none
+
+       REAL,ALLOCATABLE,DIMENSION(:) :: long,lati,area
+       REAL :: totarea
+
+       end module comgeomfi_h
+
Index: trunk/LMDZ.GENERIC/libf/phystd/comsaison_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/comsaison_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/comsaison_h.F90	(revision 787)
@@ -0,0 +1,12 @@
+
+       module comsaison_h
+
+       implicit none 
+
+       integer isaison
+       logical callsais
+       real dist_star,declin
+
+       real, allocatable, dimension(:) :: mu0,fract
+
+       end module comsaison_h
Index: trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90	(revision 787)
@@ -0,0 +1,12 @@
+
+       module comsoil_h
+
+       implicit none
+
+       real,allocatable,dimension(:) :: layer      ! soil layer depths
+       real,allocatable,dimension(:) :: mlayer     ! soil mid-layer depths
+       real,allocatable,dimension(:,:) :: inertiedat ! soil thermal inertia
+       real volcapa    ! soil volumetric heat capacitya
+
+       end module comsoil_h
+
Index: trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 787)
@@ -10,4 +10,8 @@
       use radii_mod, only : co2_reffrad
       use aerosol_mod, only : iaero_co2
+      USE surfdat_h
+      USE comgeomfi_h
+      USE tracer_h
+
 
       implicit none
@@ -55,9 +59,6 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "surfdat.h"
-#include "comgeomfi.h"
 #include "comvert.h"
 #include "callkeys.h"
-#include "tracer.h"
 
 !-----------------------------------------------------------------------
@@ -80,5 +81,5 @@
       REAL pdu(ngrid,nlayer) , pdv(ngrid,nlayer)
       REAL pduc(ngrid,nlayer) , pdvc(ngrid,nlayer)
-      REAL pq(ngridmx,nlayer,nq),pdq(ngrid,nlayer,nq)
+      REAL pq(ngrid,nlayer,nq),pdq(ngrid,nlayer,nq)
       REAL pdqc(ngrid,nlayer,nq), pdqsc(ngrid,nq)
 
@@ -92,39 +93,39 @@
       INTEGER l,ig,icap,ilay,it,iq
 
-      REAL*8 zt(ngridmx,nlayermx)
-      REAL zq(ngridmx,nlayermx,nqmx)
+      REAL*8 zt(ngrid,nlayermx)
+      REAL zq(ngrid,nlayermx,nq)
       REAL zcpi
-      REAL ztcond (ngridmx,nlayermx)
-      REAL ztnuc (ngridmx,nlayermx)
-      REAL ztcondsol(ngridmx) 
-      REAL zdiceco2(ngridmx)
-      REAL zcondicea(ngridmx,nlayermx), zcondices(ngridmx)
-      REAL zfallice(ngridmx), Mfallice(ngridmx) 
+      REAL ztcond (ngrid,nlayermx)
+      REAL ztnuc (ngrid,nlayermx)
+      REAL ztcondsol(ngrid) 
+      REAL zdiceco2(ngrid)
+      REAL zcondicea(ngrid,nlayermx), zcondices(ngrid)
+      REAL zfallice(ngrid), Mfallice(ngrid) 
       REAL zmflux(nlayermx+1)
       REAL zu(nlayermx),zv(nlayermx)
-      REAL ztsrf(ngridmx)
+      REAL ztsrf(ngrid)
       REAL ztc(nlayermx), ztm(nlayermx+1) 
       REAL zum(nlayermx+1) , zvm(nlayermx+1)
-      LOGICAL condsub(ngridmx)
+      LOGICAL condsub(ngrid)
       REAL subptimestep
       Integer Ntime
-      real masse (ngridmx,nlayermx), w(ngridmx,nlayermx,nqmx)
-      real wq(ngridmx,nlayermx+1)
+      real masse (ngrid,nlayermx), w(ngrid,nlayermx,nq)
+      real wq(ngrid,nlayermx+1)
       real vstokes,reff
 
 !     Special diagnostic variables
-      real tconda1(ngridmx,nlayermx)
-      real tconda2(ngridmx,nlayermx)
-      real zdtsig (ngridmx,nlayermx)
-      real zdt (ngridmx,nlayermx)
+      real tconda1(ngrid,nlayermx)
+      real tconda2(ngrid,nlayermx)
+      real zdtsig (ngrid,nlayermx)
+      real zdt (ngrid,nlayermx)
 
 !-----------------------------------------------------------------------
 !     Saved local variables
 
-      REAL emisref(ngridmx)
       REAL latcond
       REAL ccond
       REAL cpice
-      SAVE emisref, cpice
+      REAL,SAVE,ALLOCATABLE,DIMENSION(:) :: emisref
+      SAVE cpice
       SAVE latcond,ccond
 
@@ -155,12 +156,14 @@
       call zerophys(ngrid*nlayer*nq,pdqc)
       call zerophys(ngrid*nlayer*nq,pdtc)
-      call zerophys(ngridmx*nlayermx*nqmx,zq)
-      call zerophys(ngridmx*nlayermx,zt)
+      call zerophys(ngrid*nlayermx*nq,zq)
+      call zerophys(ngrid*nlayermx,zt)
 
 !     Initialisation
       IF (firstcall) THEN
 
+         ALLOCATE(emisref(ngrid)) !! this should be deallocated in lastcall...
+
          ! find CO2 ice tracer
-         do iq=1,nqmx
+         do iq=1,nq
             tracername=noms(iq)
             if (tracername.eq."co2_ice") then
@@ -287,5 +290,5 @@
 !     Calculate the mass of each atmospheric layer (kg.m-2)
       do  ilay=1,nlayer
-         do ig=1, ngrid
+         DO ig=1,ngrid
             masse(ig,ilay)=(pplev(ig,ilay) - pplev(ig,ilay+1)) /g
          end do
@@ -312,8 +315,8 @@
             
 !     sedimentation computed from radius computed from q in module radii_mod
-	 call co2_reffrad(zq,reffrad)
+	 call co2_reffrad(ngrid,nq,zq,reffrad)
 	 
          do  ilay=1,nlayer
-            do ig=1, ngrid
+            DO ig=1,ngrid
 
                reff = reffrad(ig,ilay,iaero_co2)
@@ -337,5 +340,5 @@
 !     Progressively accumulating the flux to the ground
 !     Mfallice is the total amount of ice fallen to the ground
-         do ig=1,ngrid
+         DO ig=1,ngrid
             Mfallice(ig) =  Mfallice(ig) + wq(ig,i_co2ice)
          end do
@@ -463,5 +466,5 @@
 !     Surface albedo and emissivity of the ground below the snow (emisref)
 !     --------------------------------------------------------------------
-      do ig =1,ngrid
+      DO ig=1,ngrid
          IF(ig.GT.ngrid/2+1) THEN
             icap=2
